/*
	download config file
*/

#include <stdlib.h>
#include <sys/reboot.h>
#include <stdio.h>
#include <unistd.h>
#include <mqueue.h>
#include <string.h>
#include <errno.h>

#include "include/DefConfig.h"
#include "include/DefCommon.h"
#include "include/DefMsg.h"

#define SW_DISK_QUEUE		"/swDiskQueue"          //queue name for DiskCenter
CONFIG_WEB_DATA cwData;         //web config data
FILE *fp;
short sendToDiskCenter(short msgID);

int main()
{
	sendToDiskCenter(MSG_DISK_SW_SAVE);
	return 0;
}

short sendToDiskCenter(short msgID)
{
	register short rval;
	register struct timespec timeStamp;
	mqd_t Qid;
	register unsigned int msg_prio;
	COMMON_MSG_DATA myComMsg;

	msg_prio = MQUEUE_DEF_PRO;
	memset(&myComMsg, 0x0, sizeof(COMMON_MSG_DATA));

	myComMsg.hdr.type = msgID;
	myComMsg.hdr.subtype = sizeof(COMMON_MSG_DATA);

	Qid = mq_open(SW_DISK_QUEUE, O_WRONLY | O_NONBLOCK, NULL);

	if(Qid == -1)
	{
		printf(strerror(errno));
		return(RTN_FAILURE);
	}
	else
	{
	}

	rval = mq_send(Qid, (const char * )&myComMsg, sizeof(COMMON_MSG_DATA), msg_prio);

	if(rval == -1 && errno == EAGAIN)
	{
		printf("-1");
		mq_close(Qid);
	}
	else if(rval == -1)
	{
		printf("-2");
		mq_close(Qid);
		Qid = -1;
		return RTN_FAILURE;
	}
	else
	{
		printf("0");
		mq_close(Qid);
	}

        return RTN_SUCCESS;
}
