/*
	Standard Input Structure
*/

#ifndef DEF_STANDARD_INPUT_DATA__
#define DEF_STANDARD_INPUT_DATA__

typedef struct InputS
{
	char sps;		//Standard Proximity Switch.(none, single, double)
	int16_t dbgi;		//Delay before gap indicaion.(seconds)
	char btntoggle;		//Enable toggle button input.(enable, disable)
	char btnnorrev;		//Enable normal/reverse input.(enable, disable)
	char pressure;		//Pressure Switch output.(closed, open)
	char distimern;		//Standard input "disable timer" for normal button.(enable, disable)
	char distimerr;		//Standard input "disable timer" for reverse button.(enable, disable)
	char distimert;		//Standard input "disable timer" for toggle button.(enable, disable)
	int16_t distime;	//Disable time for disable timer.(seconds)
	char disthrowm;		//Throw disable, manual lockout device.(enable, disable)
	int16_t disthrowmt;	//Disable time for manual throw disable.(seconds)
	char disthrowd;		//Throw disable, detect device.(enable, disable)
	int16_t disthrowdt;	//Disable time for detected occupancy throw disable.(seconds)
	char disthrowp1;	//Throw disable,PD1 detect device.(enable, disable)
	int16_t disthrowp1t;	//Disable time for PD1 detected occupancy throw disable.(seconds)
	char disthrowp2;	//Throw disable,PD2 detect device.(enable, disable)
	int16_t disthrowp2t;	//Disable time for PD2 detected occupancy throw disable.(seconds)
	char disthrowp3;	//Throw disable,PD3 detect device.(enable, disable)
	int16_t disthrowp3t;	//Disable time for PD3 detected occupancy throw disable.(seconds)
	char disthrowp4;	//Throw disable,PD4 detect device.(enable, disable)
	int16_t disthrowp4t;	//Disable time for PD4 detected occupancy throw disable.(seconds)
	double track_id1;	//track 1 input debounce timer
	double track_id2;	//track 2 input debounce timer
	double track_id3;	//track 3 input debounce timer
	double track_id4;	//track 4 input debounce timer
	int16_t dbgoi;		//Delay before gap indication during occupancy.(seconds)
}INPUT_STANDARD_DATA;
#endif

