/*
	download config file
*/

#include <stdlib.h>
#include <sys/reboot.h>
#include <stdio.h>
#include <unistd.h>
#include <mqueue.h>
#include <string.h>
#include <errno.h>

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sched.h>
#include <math.h>
#include <limits.h>
#include <sys/timeb.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <mqueue.h>
#include <sys/mman.h>
#include <sys/timerfd.h>

#include "include/DefConfig.h"
#include "include/DefCommon.h"
#include "include/DefMsg.h"
#include "include/DefDisk.h"

#define SW_DISK_QUEUE		"/swDiskQueue"          //queue name for DiskCenter
COMMON_MSG_DATA myDiskMsg;
CONFIG_WEB_DATA cwData;         //web config data
FILE *fp;
short sendToDiskCenter(short msgID, const void *msg, short size);
void putMsg1(const int16_t type, const char *format, ...);
char *data;                     //data from web page
char dataTemp[200];

int main(int argc, char **argv[])
{
	if(argc == 2)
	{
		//printf("Content-Type: text/html\n\n");
		//printf("0=%s, 1=%s\n", argv[0], argv[1]);

		putMsg1(6, (const char *)argv[1]);
	}

	return 0;
}

short sendToDiskCenter(short msgID, const void *msg, short size)
{
	register short rval;
        register struct timespec timeStamp;
        mqd_t Qid;
        register unsigned int msg_prio;

        msg_prio = MQUEUE_DEF_PRO;
        memset(&myDiskMsg, 0x0, sizeof(COMMON_MSG_DATA));

        myDiskMsg.hdr.type = msgID;
        myDiskMsg.hdr.subtype = size;

        //printf("type=%d, subtype=%d\n", myDiskMsg.hdr.type - MSG_MIN, myDiskMsg.hdr.subtype);

        if(size != 0)
        {
                memcpy(&myDiskMsg.ComMsg, msg, size);   //com msg will be used when TimeCenter return
        }

        Qid = mq_open(SW_DISK_QUEUE, O_WRONLY, (S_IRWXU | S_IRWXG | S_IRWXO) );

        if(Qid == -1)
        {
		printf("A %s", strerror(errno));
                return(RTN_FAILURE);
        }
        else
        {
        }

        rval = mq_send(Qid, (const char * )&myDiskMsg, sizeof(COMMON_MSG_DATA), msg_prio);

	if(rval == -1 && errno == EAGAIN)
        {
		printf("B %s", strerror(errno));
                mq_close(Qid);
        }
        else if(rval == -1)
        {
		printf("C %s", strerror(errno));
                mq_close(Qid);
                Qid = -1;
                return(RTN_FAILURE);
        }
        else
        {
                //printf("sendToDiskCenter success!\n");
                mq_close(Qid);
        }

        return RTN_SUCCESS;
}

void putMsg1(const int16_t type, const char *format, ...)
{
        static char RecToWrite[200];
        static char tempRec[200];

        time_t now;
        struct tm *timeptr;
        struct timespec msgTime;
        va_list arglist;

        now = time (NULL);
        timeptr = localtime(&now);
        clock_gettime( CLOCK_REALTIME, &msgTime);

        sprintf(RecToWrite, "%d %.4d-%.2d-%.2d %.2d:%.2d:%.2d:%.9lu ",
                type,
                timeptr->tm_year + 1900, timeptr->tm_mon + 1, timeptr->tm_mday,
                timeptr->tm_hour, timeptr->tm_min,
                timeptr->tm_sec, msgTime.tv_nsec
        );

        va_start(arglist, format);
        vsprintf(tempRec, format, arglist);
        va_end(arglist);

        strcat(RecToWrite, tempRec);

        DISK_DEF_DATA diskRec;
        memset(&diskRec, 0x0, sizeof(DISK_DEF_DATA));

        sprintf(diskRec.message, "%s", RecToWrite);
        if(sendToDiskCenter(MSG_DISK_SW_LOAD, &diskRec, sizeof(DISK_DEF_DATA)) == RTN_SUCCESS)
	{
		printf("1");
	}
	else
	{
		printf("2");
	}
}
